
#include <Trade\Trade.mqh>
CTrade trade;
     
//--Input parameters

input int H1_EMA50=50;
input int H1_EMA200=200;
input int M15_50EMA=50;
input int M15_200EMA=200;
input int M5_50EMA=50;

input double Lotsize=0.03;

input int EA_Magic=123;

input int StopLoss=200;
input int TakeProfit=300; 

//--Other parameters
int H1_EMA50_Handle;
int H1_EMA200_Handle;
int M15_50EMA_Handle;
int M15_200EMA_Handle;
int M5_50EMA_Handle;

double maValH1_EMA50[];
double maValH1_EMA200[];
double maValM15_50EMA[];
double maValM15_200EMA[];
double maValM5_50EMA[];

double p_close;
double p_open;
double p_high;
double p_low;

double bbl_close;
double bbl_open;
double bbl_high;
double bbl_low;

int OnInit()
   {
   //---Get handles for indicators
   H1_EMA50_Handle=iMA(_Symbol,PERIOD_H1,50,0,1,PRICE_CLOSE);
   H1_EMA200_Handle=iMA(_Symbol,PERIOD_H1,200,0,1,PRICE_CLOSE);
   M15_50EMA_Handle=iMA(_Symbol,PERIOD_M15,50,0,1,PRICE_CLOSE);
   M15_200EMA_Handle=iMA(_Symbol,PERIOD_M15,200,0,1,PRICE_CLOSE);
   M5_50EMA_Handle=iMA(_Symbol,PERIOD_M5,50,0,1,PRICE_CLOSE);
   }

void OnDeinit(const int reason)
   {
   IndicatorRelease(H1_EMA50_Handle);
   IndicatorRelease(H1_EMA200_Handle);
   IndicatorRelease(M15_50EMA_Handle);
   IndicatorRelease(M15_200EMA_Handle);
   IndicatorRelease(M5_50EMA_Handle);
   }
   
void OnTick()
   //--Is there a new bar?
   {
   static datetime Old_Time;
   datetime New_Time[1];
   bool IsNewBar=false;
   int copied=CopyTime(_Symbol,PERIOD_M5,0,1,New_Time);
   if(Old_Time!=New_Time[0])  
      {
      IsNewBar=true;
      }
   
   MqlTick latest_price;
   MqlTradeRequest mrequest;
   MqlTradeResult mresult;
   MqlRates mrates[];
   ArraySetAsSeries(mrates,true);
   ArraySetAsSeries(maValH1_EMA50,true);
   ArraySetAsSeries(maValH1_EMA200,true);
   ArraySetAsSeries(maValM15_50EMA,true);
   ArraySetAsSeries(maValM15_200EMA,true);
   ArraySetAsSeries(maValM5_50EMA,true);
   
   SymbolInfoTick(_Symbol,latest_price);
   CopyRates(_Symbol,PERIOD_M5,0,3,mrates);
   CopyBuffer(H1_EMA50_Handle,0,0,3,maValH1_EMA50);
   CopyBuffer(H1_EMA200_Handle,0,0,3,maValH1_EMA200);
   CopyBuffer(M15_50EMA_Handle,0,0,3,maValM15_50EMA);
   CopyBuffer(M15_200EMA_Handle,0,0,3,maValM15_200EMA);
   CopyBuffer(M5_50EMA_Handle,0,0,3,maValM5_50EMA);
   
   //--Is there an open position?
   bool BuyOpened=false;
   bool SellOpened=false;
   
   //--If there is an open position, what kind of position is it?
   if(PositionSelect(_Symbol)==true)
      {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
         {
         BuyOpened=true;
         }
      }
   
   if(PositionSelect(_Symbol)==true)
      {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
         {
         SellOpened=true;
         }
      }
      
   
   //--If there is an open position, what was its opening price?
   if(PositionSelect(_Symbol)==true)
      {
      PositionGetDouble(POSITION_PRICE_OPEN);
      }
   
   //--Required price details of previous 2 bars 
   p_close=mrates[1].close; //--bar 1 close price
   p_open=mrates[1].open; //--bar 1 open price
   p_high=mrates[1].high; //--bar 1 high
   p_low=mrates[1].low; //--bar 1 low
   bbl_close=mrates[2].close; //--bar 2 close price   
   bbl_open=mrates[2].open; //--bar 2 open price
   bbl_high=mrates[2].high; //--bar 2 high
   bbl_low=mrates[2].low; //--bar 2 low
   
   //--Bullish Pin Bar conditions
   bool Bullish_Pin_Bar=false;
   if(p_close>p_open)
      {
      if(p_close-p_open<0.25*(p_high-p_low))
         {
         if(p_open>p_low+(0.75*(p_high-p_low)))
         Bullish_Pin_Bar=true;
         }
      }
   
   //--Bearish Pin Bar conditions
   bool Bearish_Pin_Bar=false;
   if(p_open>p_close)
      {
      if(p_open-p_close<0.25*(p_high-p_low))
         {
         if(p_open<p_high-(0.75*(p_high-p_low)))
         Bearish_Pin_Bar=true;
         }
      }
   
   //--Bullish Engulfing Candle conditions
   bool Bullish_Engulfing_Candle=false;
   if(p_close>p_open)
      {
      if(p_close>bbl_high)
         {
         if(bbl_close<bbl_open)
         Bullish_Engulfing_Candle=true;
         }
      }
   
   //--Bearish Engulfing Candle conditions
   bool Bearish_Engulfing_Candle=false;
   if(p_open>p_close)
      {
      if(p_close<bbl_low)
         {
         if(bbl_close>bbl_open)
         Bearish_Engulfing_Candle=true;
         }
      }
   
   //--Buy conditions - remember we also need Bullish_Pin_Bar OR Bullish_Engulfing_Candle to be true!
   bool Buy_Condition_1=(maValH1_EMA50[1]>maValH1_EMA200[1]);
   bool Buy_Condition_2=(maValM15_50EMA[1]>maValM15_200EMA[1]);
   bool Buy_Condition_3=(p_close<maValM5_50EMA[1]);
   bool Buy_Condition_4=(p_close<POSITION_PRICE_OPEN);
   
   //--Sell conditions - remember we also need Bearish_Pin_Bar OR Bearish_Engulfing_Candle to be true!
   bool Sell_Condition_1=(maValH1_EMA50[1]<maValH1_EMA200[1]);
   bool Sell_Condition_2=(maValM15_50EMA[1]<maValM15_200EMA[1]);
   bool Sell_Condition_3=(p_close>maValM5_50EMA[1]);
   bool Sell_Condition_4=(p_close>POSITION_PRICE_OPEN);
   
   if(Bullish_Pin_Bar=true)
      {
      if(Buy_Condition_1 && Buy_Condition_2)
         {
         if(Buy_Condition_3 && Buy_Condition_4)
            {
            mrequest.action=TRADE_ACTION_DEAL;
            mrequest.price=NormalizeDouble(latest_price.ask,_Digits);
            mrequest.sl=NormalizeDouble(latest_price.ask-StopLoss*_Point,_Digits);
            mrequest.tp=NormalizeDouble(latest_price.ask+TakeProfit*_Point,_Digits);
            mrequest.symbol=_Symbol;
            mrequest.volume=Lotsize;
            mrequest.magic=EA_Magic;
            mrequest.type=ORDER_TYPE_BUY;
            mrequest.type_filling=ORDER_FILLING_FOK;
            mrequest.deviation=50;
            OrderSend(mrequest,mresult); //--send order
            }
         }
      }
      
   if(Bullish_Engulfing_Candle=true)
      {
      if(Buy_Condition_1 && Buy_Condition_2)
         {
         if(Buy_Condition_3 && Buy_Condition_4)
            {
            mrequest.action=TRADE_ACTION_DEAL;
            mrequest.price=NormalizeDouble(latest_price.ask,_Digits);
            mrequest.sl=NormalizeDouble(latest_price.ask-StopLoss*_Point,_Digits);
            mrequest.tp=NormalizeDouble(latest_price.ask+TakeProfit*_Point,_Digits);
            mrequest.symbol=_Symbol;
            mrequest.volume=Lotsize;
            mrequest.magic=EA_Magic;
            mrequest.type=ORDER_TYPE_BUY;
            mrequest.type_filling=ORDER_FILLING_FOK;
            mrequest.deviation=50;
            OrderSend(mrequest,mresult); //--send order
            }
         }
      }
  
   if(Bearish_Pin_Bar=true)
      {
      if(Sell_Condition_1 && Sell_Condition_2)
         {
         if(Sell_Condition_3 && Sell_Condition_4)
            {
            mrequest.action=TRADE_ACTION_DEAL;
            mrequest.price=NormalizeDouble(latest_price.bid,_Digits);
            mrequest.sl=NormalizeDouble(latest_price.bid+StopLoss*_Point,_Digits);
            mrequest.tp=NormalizeDouble(latest_price.bid-TakeProfit*_Point,_Digits);
            mrequest.symbol=_Symbol;
            mrequest.volume=Lotsize;
            mrequest.magic=EA_Magic;
            mrequest.type=ORDER_TYPE_SELL;
            mrequest.type_filling=ORDER_FILLING_FOK;
            mrequest.deviation=50;
            OrderSend(mrequest,mresult); //--send order
            }
         }
      }    
         
   if(Bearish_Engulfing_Candle=true)
      {
      if(Sell_Condition_1 && Sell_Condition_2)
         {
         if(Sell_Condition_3 && Sell_Condition_4)
            {
            mrequest.action=TRADE_ACTION_DEAL;
            mrequest.price=NormalizeDouble(latest_price.bid,_Digits);
            mrequest.sl=NormalizeDouble(latest_price.bid+StopLoss*_Point,_Digits);
            mrequest.tp=NormalizeDouble(latest_price.bid-TakeProfit*_Point,_Digits);
            mrequest.symbol=_Symbol;
            mrequest.volume=Lotsize;
            mrequest.magic=EA_Magic;
            mrequest.type=ORDER_TYPE_SELL;
            mrequest.type_filling=ORDER_FILLING_FOK;
            mrequest.deviation=50;
            OrderSend(mrequest,mresult); //--send order
            }
         }
      }    
   
   }      
           
   
   
  
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   

   
   
   
     
   
                 
         
      
   
   
  
   
      
   
      
   
     
   



   
  
   
      
   
   
   
   
   
   
   
      
     


   
